
"""
    Aignostics Platform API reference

     Pagination is done via `page` and `page_size`. Sorting via `sort` query parameter. The `sort` query parameter can be provided multiple times. The sorting direction can be indicated via `+` (ascending) or `-` (descending) (e.g. `/v1/applications?sort=+name)`.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class OutputArtifactResultReadResponse(BaseModel):
    """
    OutputArtifactResultReadResponse
    """ # noqa: E501
    output_artifact_id: StrictStr = Field(description="The Id of the artifact. Used internally")
    name: StrictStr = Field(description=" Name of the output from the output schema from the `/v1/versions/{version_id}` endpoint.     ")
    mime_type: Annotated[str, Field(strict=True)] = Field(description="The mime type of the output file")
    metadata: Dict[str, Any] = Field(description="The metadata of the output artifact, provided by the application")
    download_url: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=2083)]]
    __properties: ClassVar[List[str]] = ["output_artifact_id", "name", "mime_type", "metadata", "download_url"]

    @field_validator('mime_type')
    def mime_type_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^\w+\/\w+[-+.|\w+]+\w+$", value):
            raise ValueError(r"must validate the regular expression /^\w+\/\w+[-+.|\w+]+\w+$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OutputArtifactResultReadResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if download_url (nullable) is None
        # and model_fields_set contains the field
        if self.download_url is None and "download_url" in self.model_fields_set:
            _dict['download_url'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OutputArtifactResultReadResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "output_artifact_id": obj.get("output_artifact_id"),
            "name": obj.get("name"),
            "mime_type": obj.get("mime_type"),
            "metadata": obj.get("metadata"),
            "download_url": obj.get("download_url")
        })
        return _obj
